package be.ac.info.fundp.TVLParser.SyntaxTree;

import java.util.Vector;

import be.ac.info.fundp.TVLParser.exceptions.AmbiguousReferenceException;
import be.ac.info.fundp.TVLParser.exceptions.BadTypeUseException;
import be.ac.info.fundp.TVLParser.exceptions.ChildrenFeatureNotFoundException;
import be.ac.info.fundp.TVLParser.exceptions.ExpressionOutOfBoundException;
import be.ac.info.fundp.TVLParser.exceptions.ExpressionTypeViolatingAttributeTypeException;
import be.ac.info.fundp.TVLParser.exceptions.IDEnumValuesConflictException;
import be.ac.info.fundp.TVLParser.exceptions.IllegalExpressionException;
import be.ac.info.fundp.TVLParser.exceptions.SetExpressionMemberOutOfBoundException;
import be.ac.info.fundp.TVLParser.exceptions.SetExpressionMemberViolatingAttributeTypeException;
import be.ac.info.fundp.TVLParser.exceptions.SharedFeatureUsingParentConstructorException;
import be.ac.info.fundp.TVLParser.exceptions.SharedFeatureUsingParentSelectorException;
import be.ac.info.fundp.TVLParser.exceptions.SymbolNotFoundException;


public class ExpressionList {

	Vector<Expression> expressions;

	public ExpressionList(Expression e1) {
		this.expressions = new Vector<Expression>();
		this.expressions.add(e1);
	}
	
	public ExpressionList(Expression e1, ExpressionList e2) {
		this.expressions = e2.getExpressions();
		this.expressions.add(e1);
		//this.expressions.add(0, e1);
	}

	/**
	 * @return the expressionList
	 */
	public Vector<Expression> getExpressions() {
		return expressions;
	}
	
	public String toString() {
		String list = this.expressions.get(0).toString();
		int i = 1;
		while ( i <= this.expressions.size()-1) {
			list = list.concat(", "+this.expressions.get(i).toString());
			i++;
		}
		return list;
	}
	
	public int getType() throws IllegalExpressionException, SymbolNotFoundException, AmbiguousReferenceException, SharedFeatureUsingParentConstructorException, BadTypeUseException, SharedFeatureUsingParentSelectorException, ChildrenFeatureNotFoundException, IDEnumValuesConflictException, NumberFormatException, SetExpressionMemberOutOfBoundException, SetExpressionMemberViolatingAttributeTypeException, ExpressionTypeViolatingAttributeTypeException, ExpressionOutOfBoundException {
		int currentType = 0;
		int i = 0;
		while (i <= this.expressions.size()-1) {
			if (i == 0) {
				currentType = expressions.get(i).getType();			}
			else {
				if (currentType != expressions.get(i).getType())
					if ((currentType == Expression.REAL) && (expressions.get(i).getType() == Expression.INT)) {
						currentType = Expression.REAL;
					}
					else {
						if ((currentType == Expression.INT) && (expressions.get(i).getType() == Expression.REAL)) {
							currentType = Expression.REAL;
						}
						else {
							throw new IllegalExpressionException();
						}
					}
			}
			i++;
		}
		return currentType;
	}
}
